mkrootfs.sh.in 7.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253
  1. #!/bin/sh
  2. #-
  3. # Copyright (c) 2013-2015 Juan Romero Pardines.
  4. # All rights reserved.
  5. #
  6. # Redistribution and use in source and binary forms, with or without
  7. # modification, are permitted provided that the following conditions
  8. # are met:
  9. # 1. Redistributions of source code must retain the above copyright
  10. # notice, this list of conditions and the following disclaimer.
  11. # 2. Redistributions in binary form must reproduce the above copyright
  12. # notice, this list of conditions and the following disclaimer in the
  13. # documentation and/or other materials provided with the distribution.
  14. #
  15. # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
  16. # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  17. # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  18. # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
  19. # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
  20. # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  21. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  22. # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  23. # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  24. # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  25. #-
  26. readonly PROGNAME=$(basename $0)
  27. readonly ARCH=$(uname -m)
  28. trap 'die "Interrupted! exiting..."' INT TERM HUP
  29. info_msg() {
  30. printf "\033[1m$@\n\033[m"
  31. }
  32. die() {
  33. echo "FATAL: $@"
  34. umount_pseudofs
  35. [ -d "$rootfs" ] && rm -rf $rootfs
  36. exit 1
  37. }
  38. usage() {
  39. cat <<_EOF
  40. Usage: $PROGNAME [options] <platform>
  41. Supported platforms: i686, i686-musl, x86_64, x86_64-musl,
  42. bananapi, beaglebone, cubieboard2, cubietruck,
  43. odroid-u2, rpi, rpi2 (armv7), usbarmory
  44. Options
  45. -b <syspkg> Set an alternative base-system package (defaults to base-system)
  46. -c <dir> Set XBPS cache directory (defaults to /var/cache/xbps)
  47. -C <file> Full path to the XBPS configuration file
  48. -h Show this help
  49. -p <pkgs> Additional packages to install into the rootfs (separated by blanks)
  50. -r <repo> Set XBPS repository (may be set multiple times)
  51. -V Show version
  52. _EOF
  53. }
  54. mount_pseudofs() {
  55. for f in dev proc sys; do
  56. [ ! -d $rootfs/$f ] && mkdir -p $rootfs/$f
  57. mount -r --bind /$f $rootfs/$f
  58. done
  59. }
  60. umount_pseudofs() {
  61. for f in dev proc sys; do
  62. umount -f $rootfs/$f >/dev/null 2>&1
  63. done
  64. }
  65. run_cmd_target() {
  66. info_msg "Running $@ for target $_ARCH ..."
  67. eval XBPS_TARGET_ARCH=${_ARCH} "$@"
  68. [ $? -ne 0 ] && die "Failed to run $@"
  69. }
  70. run_cmd() {
  71. info_msg "Running $@ ..."
  72. eval "$@"
  73. [ $? -ne 0 ] && die "Failed to run $@"
  74. }
  75. register_binfmt() {
  76. if [ "$ARCH" = "${_ARCH}" ]; then
  77. return 0
  78. fi
  79. mountpoint -q /proc/sys/fs/binfmt_misc || modprobe -q binfmt_misc; mount -t binfmt_misc binfmt_misc /proc/sys/fs/binfmt_misc
  80. case "${_ARCH}" in
  81. armv?l*)
  82. echo ':arm:M::\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28\x00:\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff:/usr/bin/qemu-arm-static:' > /proc/sys/fs/binfmt_misc/register
  83. cp -f $(which qemu-arm-static) $rootfs/usr/bin || die "failed to copy qemu-arm-static to the rootfs"
  84. ;;
  85. *)
  86. die "Unknown target architecture!"
  87. ;;
  88. esac
  89. }
  90. : ${XBPS_CACHEDIR:=--cachedir=/var/cache/xbps}
  91. : ${PKGBASE:=base-system}
  92. #
  93. # main()
  94. #
  95. while getopts "b:C:c:hp:r:V" opt; do
  96. case $opt in
  97. b) PKGBASE="$OPTARG";;
  98. C) XBPS_CONFFILE="-C $OPTARG";;
  99. c) XBPS_CACHEDIR="--cachedir=$OPTARG";;
  100. h) usage; exit 0;;
  101. p) EXTRA_PKGS="$OPTARG";;
  102. r) XBPS_REPOSITORY="$XBPS_REPOSITORY --repository=$OPTARG";;
  103. V) echo "$PROGNAME @@MKLIVE_VERSION@@"; exit 0;;
  104. esac
  105. done
  106. shift $(($OPTIND - 1))
  107. PLATFORM="$1"
  108. SUBPLATFORM=$PLATFORM
  109. : ${XBPS_REPOSITORY:=--repository=http://repo.voidlinux.eu/current}
  110. if [ -z "$PLATFORM" ]; then
  111. echo "$PROGNAME: platform was not set!"
  112. usage; exit 1
  113. fi
  114. case "$PLATFORM" in
  115. bananapi) _ARCH="armv7l"; QEMU_BIN=qemu-arm-static;;
  116. beaglebone) _ARCH="armv7l"; QEMU_BIN=qemu-arm-static;;
  117. cubieboard2|cubietruck) _ARCH="armv7l"; QEMU_BIN=qemu-arm-static;;
  118. i686) _ARCH="i686"; QEMU_BIN=qemu-i386-static;;
  119. i686-musl) _ARCH="i686-musl"; QEMU_BIN=qemu-i386-static;;
  120. odroid-u2) _ARCH="armv7l"; QEMU_BIN=qemu-arm-static;;
  121. rpi) _ARCH="armv6l"; QEMU_BIN=qemu-arm-static;;
  122. rpi-musl) _ARCH="armv6l-musl"; SUBPLATFORM="rpi"; QEMU_BIN=qemu-arm-static;;
  123. rpi2) SUBPLATFORM="rpi"; _ARCH="armv7l"; QEMU_BIN=qemu-arm-static;;
  124. usbarmory) _ARCH="armv7l"; QEMU_BIN=qemu-arm-static;;
  125. x86_64) _ARCH="x86_64"; QEMU_BIN=qemu-x86_64-static;;
  126. x86_64-musl) _ARCH="x86_64-musl"; QEMU_BIN=qemu-x86_64-static;;
  127. *) die "$PROGNAME: invalid platform!";;
  128. esac
  129. if [ "$(id -u)" -ne 0 ]; then
  130. die "need root perms to continue, exiting."
  131. fi
  132. #
  133. # Check for required binaries.
  134. #
  135. for f in chroot tar xbps-install xbps-reconfigure xbps-query; do
  136. if ! $f --version >/dev/null 2>&1; then
  137. die "$f binary is missing in your system, exiting."
  138. fi
  139. done
  140. if ! $QEMU_BIN -version >/dev/null 2>&1; then
  141. die "$QEMU_BIN binary is missing in your system, exiting."
  142. fi
  143. if type pixz >/dev/null 2>&1; then
  144. XZ=pixz
  145. else
  146. XZ="xz -T0"
  147. fi
  148. #
  149. # Check if package base-system is available.
  150. #
  151. rootfs=$(mktemp -d || die "FATAL: failed to create tempdir, exiting...")
  152. mkdir -p $rootfs/var/db/xbps/keys
  153. cp keys/*.plist $rootfs/var/db/xbps/keys
  154. run_cmd_target "xbps-install -S $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -r $rootfs"
  155. run_cmd_target "xbps-query -R -r $rootfs $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -ppkgver $PKGBASE"
  156. chmod 755 $rootfs
  157. case "$PLATFORM" in
  158. i686*|x86_64*) PKGS="${PKGBASE} grub" ;;
  159. *) PKGS="${PKGBASE} ${SUBPLATFORM}-base" ;;
  160. esac
  161. [ -n "$EXTRA_PKGS" ] && PKGS="${PKGS} ${EXTRA_PKGS}"
  162. mount_pseudofs
  163. #
  164. # Install base-system to the rootfs directory.
  165. #
  166. run_cmd_target "xbps-install -S $XBPS_CONFFILE $XBPS_CACHEDIR $XBPS_REPOSITORY -r $rootfs -y ${PKGS}"
  167. # Enable en_US.UTF-8 locale and generate it into the target rootfs.
  168. if [ -e $rootfs/etc/default/libc-locales ]; then
  169. LOCALE=en_US.UTF-8
  170. sed -e "s/\#\(${LOCALE}.*\)/\1/g" -i $rootfs/etc/default/libc-locales
  171. fi
  172. #
  173. # Reconfigure packages for target architecture: must be reconfigured
  174. # thru the qemu user mode binary.
  175. #
  176. if [ -n "${_ARCH}" ]; then
  177. info_msg "Reconfiguring packages for ${_ARCH} ..."
  178. case "$PLATFORM" in
  179. i686*|x86_64*)
  180. run_cmd "XBPS_ARCH=$_ARCH xbps-reconfigure -r $rootfs base-directories"
  181. ;;
  182. *)
  183. register_binfmt
  184. run_cmd "xbps-reconfigure -r $rootfs base-directories"
  185. rmdir $rootfs/usr/lib32
  186. rm -f $rootfs/lib32 $rootfs/lib64 $rootfs/usr/lib64
  187. ;;
  188. esac
  189. run_cmd "chroot $rootfs xbps-reconfigure shadow"
  190. if [ "$PKGBASE" = "base-system-systemd" ]; then
  191. run_cmd "chroot $rootfs xbps-reconfigure systemd"
  192. fi
  193. run_cmd "chroot $rootfs xbps-reconfigure -a"
  194. else
  195. if [ "$PKGBASE" = "base-system-systemd" ]; then
  196. run_cmd "chroot $rootfs xbps-reconfigure systemd"
  197. fi
  198. fi
  199. #
  200. # Setup default root password.
  201. #
  202. run_cmd "chroot $rootfs sh -c 'echo "root:voidlinux" | chpasswd -c SHA512'"
  203. umount_pseudofs
  204. #
  205. # Cleanup rootfs.
  206. #
  207. rm -f $rootfs/etc/.pwd.lock 2>/dev/null
  208. rm -rf $rootfs/var/cache/* 2>/dev/null
  209. #
  210. # Generate final tarball.
  211. #
  212. arch=$ARCH
  213. if [ -n "${_ARCH}" ]; then
  214. rm -f $rootfs/usr/bin/$QEMU_BIN
  215. arch=${_ARCH}
  216. fi
  217. tarball=void-${PLATFORM}-rootfs-$(date '+%Y%m%d').tar.xz
  218. run_cmd "tar -cp --posix -C $rootfs . | $XZ -9 > $tarball "
  219. rm -rf $rootfs
  220. info_msg "Successfully created $tarball ($PLATFORM)"
  221. # vim: set ts=4 sw=4 et: